# 28/9/95: program to demonstate large additive modelling (non-robust)
# Note that early versions of br would crash on such models, but
# the overflow/underflow control introduced with this version
# makes such calculations much more stable.

# This requires construction of a large design matrix and machines with low
# cache and/or ram may run into difficulties. 

#generate data
x_matrix(runif(7000),1000,7)
y_sin(10*pi*x[,1])+1.5*cos(2*pi*x[,2])+2*x[,3]-x[,4]+rnorm(1000,0,1)

#split up graphics window
par(mfrow=c(3,3))

#fit model with additive componants plotted.
junk_br(xs=x,y=y,plotit=T)
