# This example illustrates the practical speed advantage of
# using this software for robust nonparametric regression.
# It shows that even for n=1500 and highly irregular function
# that it fits in reasonable time.

# generate function values
x_runif(1500)
y[x<0.5]_sin(15*pi*x[x<0.5])
y[x>0.5]_2*(x[x>0.5]-0.5)^2-1

#add normal noise
y_y+rnorm(1500)


# introduce 100 outliers
y[1:100]_rnorm(100,0,18)

#fit model
junk_br(xs=x,y=y,outlier=T)

#plot data and fit
par(mfrow=c(2,1))
plot(x,y,pch=".",main="data and fit")
lines(junk$xplot,junk$yplot+junk$beta[1])
plot(x[101:1500],y[101:1500],pch=".",main="close up")
lines(junk$xplot,junk$yplot+junk$beta[1])
