br_function(x,xs,y,density=c(0),j=c(100,100,300),plotlength=400,
	outlier=F,b=100,deltaprior=c(0.05),
	trans=F,plotit=F,type=1,seed=345986.028184573,
	indicprior=c(0.5),sens=1000)
{
	gbeta_c(0)
	lam_7
	random_F
	if(trans==F) j[2]_c(0)
	n_length(y)
	importx_c(T,T)

        if(missing(x)){
          x_matrix(c(0),n,1)
          p1_0
	  importx[1]_F
        }
        if(missing(xs)){
          xs_matrix(c(0),n,1)
          p2_0
	  importx[2]_F
        }

	if(is.matrix(x) & !missing(x)){
	  p1_dim(x)[2]
	}else if(importx[1]){
	  p1_1
	  x_matrix(x,n,1)
	}

	if(is.matrix(xs) & !missing(xs)){
	  p2_dim(xs)[2]
	}else if(importx[2]){
	  p2_1
	  xs_matrix(xs,n,1)
	}

	if(density==0){
	  density_max(4*p2,as.integer(n/35))
	}

        it_sum(round(rep(n,length=p2)/density))+p1+3*p2
	maxknot_round(n/max(density))
	it_it+1

	numk_rep(0,length=p2)
	sxs_rep(0,length=n)
	density_rep(density,length=p2)
	indic_rep(c(1,rep(0,100)),length=n)

        if(importx[2]==T){
	  knot_matrix(c(0),p2,max(round(rep(n,length=p2)/density)))
	}else{
	  knot_matrix(c(0),p2,1)
	}

	txx_matrix(c(0),it,it)
	Rone_matrix(c(0),it,it)
	Rzero_matrix(c(0),it,it)
	xplot_matrix(c(0),plotlength,p2)
	yplot_matrix(c(0),plotlength,p2)
	fpres_matrix(c(0),n,p2)
	txy_matrix(c(0),9,it)
	zz_array(c(0),dim=c(plotlength,p2,(maxknot+3)))
	xmatrix_matrix(c(0),n,it)
	wkmat_matrix(c(0),n,4)
	delta_matrix(c(0),2,n)
	
        storage.mode(x)_"double"
        storage.mode(xs)_"double"
	storage.mode(xplot)_"double"
	storage.mode(yplot)_"double"
	storage.mode(knot)_"double"
	storage.mode(txx)_"double"
	storage.mode(Rone)_"double"
	storage.mode(Rzero)_"double"
	storage.mode(fpres)_"double"
	storage.mode(txy)_"double"
	storage.mode(zz)_"double"
	storage.mode(xmatrix)_"double"
	storage.mode(wkmat)_"double"
        storage.mode(delta)_"integer"

	z_.Fortran("breg4_2",
		as.integer(n),
		as.integer(p1),
		as.integer(p2),
		x,
		xs,
		as.double(y),
		as.integer(density),
		xplot=xplot,
		yplot=yplot,
		as.integer(rep(0,n)),
		as.integer(rep(indic,length=it)),
		as.integer(j),
		as.double(sens),
		as.integer(plotlength),
		numk=as.integer(numk),
		knot=knot,
		as.double(sxs),
	        txy=txy,
		txx=txx,
		as.integer(it),
		resids=as.double(rep(0,n)),
		as.double(rep(indicprior,length=it)),
		as.double(seed),
		fpres=fpres,
		lam=as.integer(lam),
		lamprior=as.double(rep(1/9,length=9)),
		as.logical(trans),
		zz,
		beta=as.double(rep(0,length=it)),
		xmatrix=xmatrix,
		as.logical(outlier),
		delta=delta,
		as.double(rep(deltaprior,n)),
		deltamix=as.double(rep(0,n)),
		Rone,
		Rzero,
		as.integer(type),	
		wkmat,
		as.double(rep(0,n)),
		aa=as.double(rep(0,9)),
		bb=as.double(rep(0,9)),
		as.logical(random),
		as.double(b))

	if(plotit==T){
	  xlabels_paste(rep("X",length=p2),c(1:p2),sep="")
	  ylabels_paste(rep("f",length=p2),c(1:p2),sep="")
	  if(p2!=0){
            for(i in 1:p2){
	      plot(z$xplot[,i],z$yplot[,i],type="l",xlab=xlabels[i],
		main="mean",ylab=ylabels[i])
            }
	  }
	}
# construct transformation matrix.
	if(type==1)
	{
	  transf_c("-y^-2","-y^-1.5","-1/y","-1/sqrt(y)","log(y)",
		"sqrt(y)","y","y^1.5","y^2")
	}else
	{
	  transf_c("psi^-1(y^0.1)","psi^-1(y^0.25)","psi^-1(y^0.5)",
		"psi^-1(y^0.75)","psi^-1(y)","psi^-1(y^1.5)",
		"psi^-1(y^2)","logit(y)","log(-log(1-y))")
	}
	if(trans==T)
	{
	  tab_cbind(round(z$aa,5),round(z$bb,5),z$lamprior)
	  dimnames(tab)_list(transf,c("a","b","prob"))
	}else{
	  tab_"transformation not estimated"
	}

	list(xplot=z$xplot,yplot=z$yplot,resids=z$resids,
		numk=z$numk,fpres=z$fpres,beta=z$beta[1:(p1+1)],
		tab=tab,delta=z$deltamix,knot=z$knot)
}
#_______________________________________________________________
